<?php
/***********************************************************
* This file was created by Jrme Poulin under the phpmytourney
* project.  
* You can modify and redistribute this file as long as this
* copyright notice stays in the file.
*
* If you want to do major upgrades on my script, please contact
* me and we could work together.
* 
* Jrme Poulin
* Student University of Sherbrooke
* poulinjerome@hotmail.com <== dont use for support !!!
* http:/phpmytourney.sourceforge.net/ <== use sourceforce forum for support
* 
*  phpMyTourney <C> 2001-2002
************************************************************/


include($path_common . 'functions.inc');
$cur_version = "1.0.4a";

$tourney_types[0][0] = 1;
$tourney_types[0][1] = "Single Elimination";
//$tourney_types[1][0] = 2;
//$tourney_types[1][1] = "Double Elimination";
$tourney_types[1][0] = 3;
$tourney_types[1][1] = "Blind Draw";

function get_tourney_type_name($id){
	global $tourney_types;
	return $tourney_types[$id - 1][1];	
}

function get_tourney_team_list($id){

	
	$allies = get_mysql_rows($sql);
	$members_list = "- " . get_player_name($id);
	$nb = get_nb_per_team($tourney_id);
	for($i=1;$i<$nb;$i++)
		if($allies[$i][0] > 0)
			$members_list .= "<br>- " . get_player_name($allies[$i][0]);
	return $members_list;
}
function main_signup($id){
	global $tourney_id;
	$sql = "SELECT id from tourney_signup_" . $tourney_id . " where id ='$id'";
	return get_mysql_value($sql);
}
function is_signed_up($id){
	global $tourney_id;
	$sql = "SELECT pid from tourney_team_members_" . $tourney_id . " where pid = '$id'";
	return main_signup($id) or get_mysql_value($sql);
}
function get_tourney_type($tourney_id){
	$status_nb = get_status($tourney_id);
	if(($nb = get_nb_per_team($tourney_id)) && ($type = get_tourney_type_id($tourney_id))){
		if ($nb == 1 or ($type == 3 && $status_nb < 8))  return "player";
		else return "team";
		
	}
	return 0;
}
function get_tourney_type_id($tourney_id){
	$sql = "SELECT ttype from  " . $GLOBALS['dbtable_header'] . "info where id='$tourney_id'";
	return get_mysql_value($sql);
}
function get_nb_per_team($tourney_id){
	$sql = "SELECT nb_per_team from  " . $GLOBALS['dbtable_header'] . "info where id = '$tourney_id'";
	return get_mysql_value($sql);
}
function get_nb_round($nb_p){
	$round = 1; 
	for($i=$nb_p;$i>1;$i=$i/2) $round++;
	return $round - 1;
}
function get_status($tourney_id){
	$sql = "Select status from  " . $GLOBALS['dbtable_header'] . "info where id='$tourney_id'";
	return get_mysql_value($sql);
}
function get_ordre($pid){
	global $tourney_id;
	$sql = "SELECT ordre FROM tourney_signup_" . $tourney_id . " WHERE id='$pid'";
	return get_mysql_value($sql);
}
function report_loss_tourney($id,$comment =""){
	global $tourney_id;
	if(!is_in_tourney($id)) print_error("You Aren't in the standings Grid...");
	else if (is_dead($id)) print_error("You Allready Report loss...");
	else{
		$round = get_current_round($id);
		$position_loser = get_position($id,$round);
		$position_winner = get_position_winner($position_loser);

		if ($pid_winner = get_pid_position($position_winner,$round)){ 
			//This parts updates the tourney_data table...
			$new_round = $round + 1;
			$new_position = get_new_position($position_winner);
			$sql[] = "UPDATE tourney_data_" . $tourney_id . " SET
				  r" . $new_round . " = '$new_position',
				  curround = '$new_round'
				  WHERE id = '$pid_winner'";
			$sql[] = "UPDATE tourney_data_" . $tourney_id . " SET
				 dead = '1',
				 commment='$comment'
				 WHERE id='$id'";	
			if(execute_queries($sql)){
				echo("Reported Loss Successful");
			
				//This parts is added to log players matches in league stats
				//update_stats_loser($id,"lge_player_tourney_stats");
				//update_stats_winner($pid_winner,"lge_player_tourney_stats");
				return 1;
			}
			
		}
		else print_error("You must have an opposent in the grid prior to reporting loss");
	}
	return 0;

}
function insert_tourney_stats($id){
	//$sql = "INSERT into lge_player_tourney_stats SET id='$id'";
	//return execute_query($sql);
}
function get_new_position($pos){
	if(($pos % 2) == 1) return (($pos+1)/2); 
	else return ($pos/2);
}
function get_pid_position($pos,$round){
	global $tourney_id;
	$sql = "SELECT id from tourney_data_" . $tourney_id . " WHERE
		r" . $round . " = '$pos'";
	return get_mysql_value($sql);

}
function get_position_winner($position){
	if(($position % 2) == 1) return ($position+1) ;
	else return ($position-1);
}
function get_position($id,$round){
	global $tourney_id;
	$sql = "SELECT r" . $round . " from tourney_data_" . $tourney_id . " WHERE id='$id'";
	return get_mysql_value($sql);
}
function get_current_round($id){
	global $tourney_id;
	$sql = "SELECT curround from tourney_data_" . $tourney_id . " WHERE id='$id'";
	return get_mysql_value($sql);
}
function is_in_tourney($id){
	global $tourney_id;
	$sql = "SELECT id from tourney_data_" . $tourney_id . " where id='$id'";
	return get_mysql_value($sql);
}
function is_dead($id){
	global $tourney_id;
	$sql = "select dead from tourney_data_" . $tourney_id . " where id='$id'";
	return get_mysql_value($sql);
}
function get_curround($id){
	global $tourney_id;
	$sql = "SELECT curround from tourney_data_" . $tourney_id . " where id='$id'";
	return get_mysql_value($sql);
}
//**********************************************
// 	0 = sign up...
//	1 = Nottin (tourney without sign up)
//	2 = Check in ..
//	3 = Check in (Tourney without sign up) 
//	4 = Playing
//	6 = over
function do_not_remove_please(){global $cur_version; echo("<font size=\"-1\"><P><center>Powered by <a href=\"http://phpmytourney.sourceforge.net/\">phpMyTourney</a>.<br>Version " . $cur_version . "<br>Created by <a href=\"mailto:poulinjerome@hotmail.com\">Jrme Poulin</a> &copy 2001-2002</p></font>");}
//**********************************************
function update_status($new_status){
	global $tourney_id;
	//if ($new_status <= get_status($tourney_id))	print_error("Can't change status to lower or equal number");
	//else{
		$sql = "UPDATE  " . $GLOBALS['dbtable_header'] . "info SET status='$new_status' where id='$tourney_id'";
		if(execute_query($sql))
			return 1;
	//}
	return 0;
}
function print_status_legende(){
	echo("<p>STATUS : ");
	echo("<br>0 ==> Stand by...");
	echo("<br>1 ==> Sign up normal tourney");
	echo("<br>2 ==> Check-in normal tourney");
	//echo("<br>3 ==> Sign up top players tourney(no signup...)");
	//echo("<br>4 ==> Check-in top players tourney(fill the sign up table with top players)");
	//echo("<br>7 ==> Start Tourney (generate grid according to ranks (order) etc...)");
	echo("<br>8 ==> Start Tourney (generate grid randomly (shuffle players) etc...)");
	echo("<br>9 ==> Over");
	
	print_error("IMPORTANT : MAKE SURE YOU ALWAYS HAVE A VALID STATUS NUMBER IN DATABASE !!!");
}
function get_status_name($nb){
	if($nb == 0) return "Stand By";
	if($nb == 1) return "Sign up";
	if($nb == 2) return "Checkin";	
	if($nb == 8) return "Playing";
	if($nb == 9) return "Over";
	return "Unknown";
}

function fill_signup_table($tourney_id){
	//Here i could had used a simple sql statements with a select in the insert BUT
	//MySQL doesnt support the ORDER BY close in SELECT statement within INSERT and
	//it is important that player are entered in the proper order... BEcause the highed
	//Has priority ... SO all this shit is to simulate with could had been a simple SQL.
	//
	// This shit doest an awful lot of SQL queries , but it only run once per tourney(not every tourney)
	// and only by admins...
	
	$sql = "SELECT rank,id FROM lge_player_standings_mix WHERE rank != 0 ORDER BY rank";
	$players = get_mysql_rows($sql);

	$nb = count($players);
	for($i=0;$i<$nb;$i++){
		$sql = "INSERT into tourney_signup_" . $tourney_id . " VALUES(". $players[$i][0] . "," . $players[$i][1] .",0)";
		execute_query($sql);
	}
}
function generate_team_blind_draw(){
	global $tourney_id;
	$nb_per_team = get_nb_per_team($tourney_id);
	$get_sql = "SELECT id from tourney_signup_" . $tourney_id . " WHERE checkin='1' ORDER BY ordre";
	
	$checked_in = get_mysql_rows($get_sql);
	shuffle($checked_in);
	$nb_checked = count($checked_in);
	$nb_player_that_can_play = $nb_checked - ($nb_checked % $nb_per_team);
	$nb_team = $nb_player_that_can_play / $nb_per_team;
	
	//Makes the first "$nb_team" in Checkin array the team's captain by assign em team name.
	for($i=0;$i<$nb_player_that_can_play;$i += $nb_per_team){
		
		$id_captain = $checked_in[$i][0];
		$team_name = "Team ";
		$name_captain = get_player_name($id_captain);
		$team_name .= $name_captain;
		for($j=1;$j<$nb_per_team;$j++){
			
			$nb = $j+1;
			$id = $checked_in[$i+$j][0];
			$sql[] = "DELETE from tourney_signup_" . $tourney_id . " WHERE id = '$id'";
			$sql[] = "INSERT INTO tourney_team_members_" . $tourney_id . " SET nb='$nb', id='$id_captain', pid='$id'";
		}
		$sql[] = "UPDATE tourney_signup_" . $tourney_id . " SET teamname = '$team_name' WHERE id = '$id_captain' ";
		$sql[] = "INSERT INTO tourney_team_members_" . $tourney_id . " SET nb='1', id='$id_captain',pid='$id_captain'";
	}
	//remove the others from sign up table to fix some visual bugs.
	echo($nb_player_that_can_play . $nb_checked);
	if($nb_player_that_can_play > 0){
		for($i=($nb_player_that_can_play-1);$i<$nb_checked;$i++){
			echo("bob");
			$id = $checked_in[$i][0];
			$sql[] = "DELETE from tourney_signup_" . $tourney_id . " WHERE id = '$id'";
		}
	}
	else
		return false;	// 0 team created, sa suce sa.
	//delete the non-checked in ...
	$sql[] = "DELETE from tourney_signup_" . $tourney_id . " where checkin='0'";
	if(execute_queries($sql,"DEBUG")){
		echo("<br>" . $nb_team . " TEAMS WERE CREATED USING THE BLIND DRAW FUNCTION");	
		return true;
	}
	return false;
}
function start_tourney_shuffle($nb){
	global $tourney_id;
	$sql = "SELECT id from tourney_signup_" . $tourney_id . " WHERE checkin='1' ORDER BY ordre";
	$checked_in = get_mysql_rows($sql);
	shuffle($checked_in);
	$nb_checked = count($checked_in);
	if($nb_checked < $nb){	//add byes at the end with last players...
		$nb_bye = $nb - $nb_checked;
		$last_p = $nb_checked - 1;
		$last_b = $nb - 1;
		for($i=0;$i<$nb_bye;$i++){
			$checked_in[$last_b][0] = $checked_in[$last_p][0];	//put last player at last spot...
			$last_b--;
			$checked_in[$last_b][0] = 0;			//add 1 bye
			$last_b--;
			$last_p--;
		}
	}	
	for($i=0;$i<$nb;$i++){
		$grid = $i+1;
		$sql = "INSERT INTO tourney_data_" . $tourney_id . " SET dead = '0', curround = '1', r1='$grid',id=" . $checked_in[$i][0];
		execute_query($sql);
	}
}
function start_tourney_order($nb){
	global $tourney_id;
	$sql = "SELECT id from tourney_signup_" . $tourney_id . " WHERE checkin='1' ORDER BY ordre";
	$checked_in = get_mysql_rows($sql);
	$nb_checked = count($checked_in); 
	for($i=$nb_checked;$i<$nb;$i++)	//add the appropriate number of bye at the end...
		$checked_in[$i][0] = 0;
	//This function return an array containing the order to add the player
	$order = get_grid_order($nb);
	
	//Insert them according to returned order...
	for($i=1;$i<=$nb;$i++){
		$indice = $order[$i];
		$id = $checked_in[$indice-1][0];
		$sql = "INSERT INTO tourney_data_" . $tourney_id . " SET dead = '0', curround = '1', r1='$i',id=" . $id;
		execute_query($sql);
	}
	
}
function get_grid_order($nb){
	$nb_round = get_nb_round($nb);
	$round1[0] = 2;		//this contains the number of player for round
	$round1[1] = 1;
	$round1[2] = 2;

	for($i=2;$i<=$nb_round;$i++){
		$array_name = "round" . $i;
		$before_array_name = "round" . ($i -1);
		${$array_name}[0] = ${$before_array_name}[0] * 2;
		$nombre = ${$array_name}[0] + 1;
		$cpt = 1;
		for($j=1;$j<=${$before_array_name}[0];$j++){
			${$array_name}[$cpt] = ${$before_array_name}[$j];
			$cpt++;
			${$array_name}[$cpt] = $nombre - ${$array_name}[$cpt-1];
			$cpt++;
		}
	}
	$array_name = "round" . $nb_round;
	return ${$array_name};
}
function get_nb_signup($tourney_id){
	$sql = "SELECT count(id) from tourney_signup_" . $tourney_id;
	return get_mysql_value($sql);
}	
function get_nb_checked($tourney_id){
	$sql = "SELECT count(id) from tourney_signup_" . $tourney_id . " WHERE checkin ='1'";
	return get_mysql_value($sql);
}
function get_nb_tourney($tourney_id){
	$sql = "SELECT count(r1) from tourney_data_" . $tourney_id;
	return get_mysql_value($sql);
}
function checkin_sql($id){
	global $tourney_id;
if(has_checked_in($id))	print_error("You Allready Checked in");
else{
	$sql[] = "UPDATE tourney_signup_" . $tourney_id . " SET checkin='1' where id='$id'";
	
	//if(!has_tourney_stats($id)) insert_tourney_stats($id);
	//$sql[] = "UPDATE lge_player_tourney_stats SET tplayed = tplayed+1 where id='$id'";
	if(execute_queries($sql))
		echo("<br>Checked in succesful");
	else
		echo("<br>An error Occured During check in");
}
}
function has_checked_in($id){
	global $tourney_id;
	$sql = "select id from tourney_signup_" . $tourney_id . " where id='$id' and checkin='1'";
	return get_mysql_value($sql);
}
/****************
Admin function...
****************/
function print_players_data($tourney_id){
	$sql = "SELECT a.r1,a.r2,a.r3,a.r4,a.r5,a.r6,a.r7,a.r8,a.dead,a.curround,a.id
			FROM 	tourney_data_" . $tourney_id . " a
			ORDER BY a.r1";
	$array = get_mysql_rows($sql,"no");
if($array){
	$tou_type = get_tourney_type($tourney_id);
	$translate_fct = "translate_to_" . $tou_type . "_page_link";
	
	$header[0][0] = "r1";
	$header[0][1] = "r2";
	$header[0][2] = "r3";
	$header[0][3] = "r4";
	$header[0][4] = "r5";
	$header[0][5] = "r6";
	$header[0][6] = "r7";
	$header[0][7] = "r8";
	$header[0][8] = "Dead";
	$header[0][9] = "Curround";
	$header[0][10] = "Name";
	$header[0][11] = "Report loss";
	$header[0][12] = "Replace Bye";
	$nb = count($array);
	for($i=0;$i<$nb;$i++){
		$id = $array[$i][10];
		$dead = $array[$i][8];
		$bye = 0;
		if($tou_type == "team")
			$name = get_team_name(get_players_team($id));
		else
			$name = get_player_name($id);
		if (!$name){
			 $name = "-={ BYE } =-";
			 $bye = 1;
		}
		if ($dead  == 0) $array[$i][8] = "No";
		else $array[$i][8] = "Yes";
		if($bye) $array[$i][10] = $name;
		else $array[$i][10] = $name;
		if (!$bye && !$dead) $array[$i][11] = "<a href=\"adminmysql.php?action=reportloss&tourney_id=" . $tourney_id . "&id=" . $id ."\">Report Loss</a>";
		if ($bye && !$dead) $array[$i][12] = "<a href=\"adminfunctions.php?action=replacebye&tourney_id=" . $tourney_id . "&pos=" . $array[$i][0] ."\">Replace Bye</a>";
	}
	$table = array_merge($header,$array);
	print_table($table,"Tourney Data Table");
}
else
	print_error("Tourney data not available");
}
//added jp 2002-02-23
function print_add_player($tourney_id){

	$tou_type = get_tourney_type($tourney_id);
	if($tou_type == "team"){
		$rows = get_mysql_rows("SELECT a.id, a.name from ALLTOURNEY_players a LEFT JOIN tourney_team_members_" . $tourney_id . " b ON a.id=b.pid WHERE b.pid IS NULL");	
		$cboxname = "Captain";
	}
	else{
		$rows = get_mysql_rows("SELECT a.id, a.name from ALLTOURNEY_players a LEFT JOIN tourney_signup_" . $tourney_id . " b ON a.id=b.id WHERE b.id IS NULL");
		$cboxname = "Player ";
	}
	if($rows){
		print_top_form("Pick a " . $tou_type . " to add","POST","adminmysql.php");
		print_select_2dim_array($cboxname,"id",$rows);
		if($tou_type == "team") print_textbox("Team name","teamname");	
		echo("	<input type=\"HIDDEN\" name=\"action\" value=\"add_player\">
			<input type=\"HIDDEN\" name=\"tourney_id\" value=\"" . $tourney_id . "\">");
		print_submit("Add this " . $tou_type);
	}
	else
		echo("No more " . $tou_type . " can be added");
}

function print_players_signup($tourney_id){
	$sql = "SELECT a.ordre,b.name, a.checkin,a.id
			FROM 	tourney_signup_" . $tourney_id . " a,
				ALLTOURNEY_players b
			WHERE 	a.id = b.id
			ORDER by a.ordre";
	$array = get_mysql_rows($sql,"no");
if($array){	
	$tou_type = get_tourney_type($tourney_id);
	$translate_fct = "translate_to_" . $tou_type . "_page_link";
	$get_name_fct = "get_" . $tou_type . "_name";
	
	$header[0][] = "order";
	$header[0][] = "Name";
	$header[0][] = "Team Members";
	$header[0][] = "checkin";
	$header[0][] = "Check in";
	$header[0][] = "Remove";
	
	$nb = count($array);
	for($i=0;$i<$nb;$i++){
		$id = $array[$i][3];
		$tid = $id; // The temporary team created has the same id as team captain.
		$checked = $array[$i][2];
		if (!$checked){
			 $array[$i][3] = "No";
			 $array[$i][4] = "<a href=\"adminmysql.php?action=checkin_adm&tourney_id=" . $tourney_id . "&id=" . $id ."\">Check in</a>"; 
		}
		else{
			 $array[$i][3] = "Yes";
			 $array[$i][4] = " ";
		}
		
		$array[$i][5] = "<a href=\"adminmysql.php?action=remove_from_tourney&tourney_id=" . $tourney_id . "&id=" . $id . "\">Remove</a>";
		
		$array[$i][1] = $get_name_fct($id);
		if ($tou_type == "team") 
			$array[$i][2] = get_tourney_team_list($id);
		else
			$array[$i][2] = "~ singles ~";
	}
	$table = array_merge($header,$array);
	print_table($table,"Tourney Sign up Table");
}
else
	print_error("No players signed up yet...");
}
function viewplayers(){
	global $tourney_id;
	$tname = get_tourney_name($tourney_id);
	echo("<br><center><b>TOURNEY MANAGER</B><br>" . $tname . "</center>");
	$status = get_status($tourney_id);
	//print un boutton refresh!
	print_refresh_button();
	
	if ($status >= 7){
		print_players_data($tourney_id);
		print_report_bye($tourney_id);
	}
	else{
		print_add_player($tourney_id);
		print_players_signup($tourney_id);
	}
}
function end_tourney($tourney_id){
	// do nottin function, remove the code here instead of removing all the call
	// to this functions...
	
	//for now this functions only update tourney won for tourney champ
	//$pid = get_champion_id($tourney_id);
	//$sql = "UPDATE lge_player_tourney_stats SET twon = twon+1 where id='$pid'";
	//execute_query($sql);
}
function print_refresh_button(){
	global $action,$tourney_id;
	print_top_form("Refresh");
	echo("<input type=\"HIDDEN\" name=\"action\" value=\"" . $action . "\">");
	echo("<input type=\"HIDDEN\" name=\"tourney_id\" value=\"" . $tourney_id . "\">");	
	print_submit("Refresh");
}
function print_report_bye($tourney_id){
	print_top_form("Report Bye","POST","adminmysql.php");
	echo("<input type=\"HIDDEN\" name=\"tourney_id\" value=\"" . $tourney_id . "\">");
	echo("<input type=\"HIDDEN\" name=\"action\" value=\"reportbye\">");
	print_submit("Report Bye");
}	
function get_champion_name($tourney_id){
	$tou_type = get_tourney_type($tourney_id);
	$pid = get_champion_id($tourney_id);
	if($tou_type == "team"){
		$sql = "SELECT teamname from tourney_signup_" . $tourney_id . " where id = '$pid'";
		return get_mysql_value($sql);
	}
	else
		return get_player_name($pid);
}
function get_champion_id($tourney_id){
	$max_round = get_max_round($tourney_id);
	$sql = "SELECT id from tourney_data_" . $tourney_id . " where curround = '$max_round'";
	return get_mysql_value($sql);
}
function get_max_round($tourney_id){
	$sql = "SELECT max(curround) from tourney_data_" . $tourney_id; 
	return get_mysql_value($sql);
}
// ADDED team tourney related functions ~ 2 feb 2002 ~ Jrme Poulin
function get_team_name($id){
	global $tourney_id;
	$sql = "SELECT teamname from tourney_signup_" . $tourney_id . " where tid='$id'";
	return get_mysql_value($sql);
}
function get_players_team($pid){
	global $tourney_id;
	//first look he is in team_member table
	$sql = "select id from tourney_team_members_" . $tourney_id . " where pid ='$pid'";
	$tid = get_mysql_value($sql);
	
	// if did not find it he could be a captain...
	//if(!$tid){
	//	$sql = "SELECT tid from tourney_signup_" . $tourney_id . " where id='$id'";
	//	$tid = get_mysql_value($sql);
	//}
	return $tid;
}

function signup_sql($id,$teamname){
	global $tourney_id;
	$sql = "INSERT INTO tourney_signup_" . $tourney_id . " SET checkin='0', id='$id',tid='$id',teamname='$teamname'";
	return execute_query($sql);
}
function insert_in_team_members($id){
	global $tourney_id;
	// ajout du captain...
	$sql[] = "INSERT into tourney_team_members_" . $tourney_id . " SET nb='1',pid='$id',id='$id'";
	
	$nb = get_nb_per_team($tourney_id);
	for($i=2;$i<=$nb;$i++)
		$sql[] = "INSERT INTO tourney_team_members_" . $tourney_id . " SET nb='$i', id='$id'";
	return execute_queries($sql);
}

// Added 2002-02-23 JP.
function get_tourney_name($tourney_id){
	$sql = "Select tname from  " . $GLOBALS['dbtable_header'] . "info where id = '$tourney_id'";
	return get_mysql_value($sql);	
}
?>